;PRUE_TX.ASM
;Programa que transmite ciclicamente datos de 0 al 15 hacia el PC

OPTION  EQU $39
PIOC    EQU $02
PORTA   EQU $00
PORTD   EQU $08
DDRD    EQU $09
PORTE   EQU $0A
SCCR2   EQU $2D
SPCR    EQU $28
HPRIO   EQU $3C
TMSK1   EQU $22
TMSK2   EQU $24
TFLG1   EQU $23
TCTL1   EQU $20
DIRPC   EQU $00

        ORG $0000	;RAM

        BRA config
	
;variables

dato_recibido  DB 0
dato           DB 0

config	LDX #$1000
        LDS #$00B4              ; Pila en DIR 180

		
        LDAA #$00
        STAA  SCCR2,X           ; SCI deshabilitado
	
        LDAA #$30
        STAA  SPCR,X            ; SPI deshabilitado y salidas OC
	
        LDAA  #$30              ; BITS 0 a 3 del puerto D entradas,
        STAA  DDRD,X            ; BITS 4 y 5 del puerto D salidas


        LDAA  #$20
        STAA  PORTD,X           ; BIT 4 a 0 y BIT 5 del puerto D a 1
	
        BSET OPTION,X $20       ; IRQ activa por flanco de bajada

        LDAA #$C6
        STAA HPRIO,X            ;Maxima prioridad IRQ

        LDAA #$00
        STAA TMSK1,X            ; No permitir la interupcin de los comparadores

        LDAA #$00
        STAA dato_recibido

        LDY #$FFFF         ; Realizar una pausa
dec     DEY
        CPY #0
        BNE dec
        
        CLI                ; permite interrupciones

        LDAA #DIRPC
inicio  LDAB #00
        STAB dato
bucle   BSR enviar         ; envia el dato
        LDAA #DIRPC
        INC dato
        LDAB dato
        CMPB #16
        BEQ inicio
        BRA bucle

;Funcion enviar: Transmite el dato en B a la direccion en A

enviar  BRSET PORTD,X $10 enviar ;espera a que se termine la anterior transmision
	
        BSET DDRD,X $0F          ;BITS 0 a 3 del puerto D salidas

        ANDA #$0F
        ORAA #$10
        STAA PORTD,X             ;Escribe la direccion destino e inicia la transmision

        BSET PORTD,X $20          
        BSET PORTD,X $20
        BSET PORTD,X $20
        BSET PORTD,X $20         ;Se repite para que transcurra thl

        ORAB #$30
        STAB PORTD,X             ;Escribe el dato a transmitir

        ANDA #$0F
                
	RTS

;Rutina de atencion a la interrupcion externa IRQ

int_irq BRSET PORTD,X $10 fin_tr  ;Si se estaba transmitiendo salta a finalizar la transmision
        LDAA #$01
        STAA dato_recibido        ;Si no se estaba transmitiendo activa dato_recibido
        RTI
fin_tr  BCLR DDRD,X $0F           ;BITS 0 a 3 del puerto D entradas
        BCLR PORTD,X $10          ;Pone la tarjeta en recepcion
        RTI

        ORG $00EE
        JMP int_irq

	END