//simple.c
/* Programa para mandar comandos de movimiento al microbot
con interfaz de panel para el usuario */

/*---------------------- Librerias incluidas -------------------------*/

#include <dos.h>
#include "userint.h"
#include "panel.h"

/*---------------------- Definicion de constantes ---------------------*/

#define TRUE 1
#define FALSE 0
#define DELANTE 0x01
#define ATRAS 0x02
#define IZQUIERDA 0x04
#define DERECHA 0x08
#define PARO 0x0F
#define DATA 0x378
#define STATUS 0X379
#define CONTROL 0X37A

/*-----------------------Funciones----------------------------*/

void enviar(unsigned short int dir_robot,int comando);

/*----------------------Programa principal--------------------*/

main()
{
    int p,ctrl;
    unsigned short int robot,temp;
    outportb(CONTROL,0x00);        // configura el Modem en transmision con la interrupcion del PP deshabilitada
    p=LoadPanel("panel.uir",MAIN); // Carga el panel
    DisplayPanel(p);               // Visualiza el panel
    while(TRUE){
	GetUserEvent(1,&p,&ctrl);  // Espera un evento del panel
	GetCtrlVal(p, MAIN_ROBOT, &robot);
	switch(ctrl){
	    case MAIN_STOP:enviar(robot,PARO);
		 break;
	    case MAIN_DELANTE:enviar(robot,DELANTE);
		 break;
	    case MAIN_ATRAS:enviar(robot,ATRAS);
		 break;
	    case MAIN_IZQUIERDA:enviar(robot,IZQUIERDA);
		 break;
	    case MAIN_DERECHA:enviar(robot,DERECHA);
		 break;
	    case MAIN_SALIR:outportb(CONTROL,0x00);
		 return;
		 break;
	    case MAIN_PASOS:     // Se ha pulsado el boton 'Pasos restantes'
		 GetCtrlVal(p, MAIN_NUMPASOS, &temp);
		 enviar(robot,temp);  // Envia el dato que hubiera en la casilla 'Numero de pasos'
		 break;
	    }
     }
}
/*--------------------------Funcion enviar-----------------------*/
void enviar(unsigned short int dir_robot,int comando)
{
     outportb(DATA,(dir_robot<<4) | (comando & 0x0F)); // Escribe el comando en el modem junto con la dir destino
     outportb(CONTROL,0x01);   // Activa la transmision
}